### Client side

import pygame
import client
import things

class TinyMap:

    def __init__(self,grid):
        self.mapsize = len(grid[0])
        self.surface = pygame.Surface((self.mapsize*2,
                                       self.mapsize*2))
        self.scratch = pygame.Surface((self.mapsize*2,
                                       self.mapsize*2))

        for y in range(self.mapsize):
            for x in range(self.mapsize):
                id = grid[x][y].id
                if id < 50: color = (30,30,30)
                else: color = (0,200,0)
                pygame.draw.polygon(self.scratch, color, [(2*x,2*y),
                                                          (2*x+1,2*y),
                                                          (2*x+1,2*y+1),
                                                          (2*x,2*y+1),
                                                          ])

        self.dots = {'red': pygame.Surface((5,5)),
                     'blue': pygame.Surface((5,5)),
                     'yellow': pygame.Surface((5,5)),
                     }

        self.dots['red'].set_colorkey((0,0,0))
        self.dots['blue'].set_colorkey((0,0,0))
        self.dots['yellow'].set_colorkey((0,0,0))

        pygame.draw.circle(self.dots['red'], (255,0,0), (2,2), 2)
        pygame.draw.circle(self.dots['blue'], (0,0,255), (2,2), 2)
        pygame.draw.circle(self.dots['yellow'], (255,255,0), (2,2), 2)
                           
        self.update()

    def update(self):
        self.surface.blit(self.scratch,(0,0))
        for thing in client.things.values():
            if isinstance(thing,things.Player): dot = 'red'
            elif isinstance(thing,things.Item): dot = 'yellow'
            else: dot = 'blue'
            self.surface.blit(self.dots[dot],(2*thing.position[0]-1,
                                             2*thing.position[1]-1))
                        
    def draw(self,screen):
        screen.blit(self.surface,(client.viewsize+(client.panelsize-self.surface.get_width())/2,400))
